
;CodeVisionAVR C Compiler V1.25.8 Standard
;(C) Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATtiny2313
;Clock frequency        : 8,000000 MHz
;Memory model           : Tiny
;Optimize for           : Speed
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 32 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATtiny2313
	#pragma AVRPART MEMORY PROG_FLASH 2048
	#pragma AVRPART MEMORY EEPROM 128
	#pragma AVRPART MEMORY INT_SRAM SIZE 128
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU WDTCR=0x21
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SREG=0x3F
	.EQU GPIOR0=0x13
	.EQU GPIOR1=0x14
	.EQU GPIOR2=0x15

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "t13.vec"
	.INCLUDE "t13.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x80)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0-GPIOR2 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30
	LDI  R30,__GPIOR1_INIT
	OUT  GPIOR1,R30
	LDI  R30,__GPIOR2_INIT
	OUT  GPIOR2,R30

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0xDF)
	OUT  SPL,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x80)
	LDI  R29,HIGH(0x80)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x80
;       1 /*****************************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.25.8 Standard
;       4 Automatic Program Generator
;       5  Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;       6 http://www.hpinfotech.com
;       7 
;       8 Project :
;       9 Version :
;      10 Date    : 27.06.2011
;      11 Author  : F4CG
;      12 Company : F4CG
;      13 Comments:
;      14 
;      15 
;      16 Chip type           : ATtiny2313
;      17 Clock frequency     : 8,000000 MHz
;      18 Memory model        : Tiny
;      19 External SRAM size  : 0
;      20 Data Stack size     : 32
;      21 *****************************************************/
;      22 
;      23 #include <tiny2313.h>
;      24 	#ifndef __SLEEP_DEFINED__
	#ifndef __SLEEP_DEFINED__
;      25 	#define __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
;      26 	.EQU __se_bit=0x20
	.EQU __se_bit=0x20
;      27 	.EQU __sm_mask=0x50
	.EQU __sm_mask=0x50
;      28 	.EQU __sm_powerdown=0x10
	.EQU __sm_powerdown=0x10
;      29 	.EQU __sm_standby=0x40
	.EQU __sm_standby=0x40
;      30 	.SET power_ctrl_reg=mcucr
	.SET power_ctrl_reg=mcucr
;      31 	#endif
	#endif
;      32 #include <delay.h>
;      33 #define start PINA.1
;      34 #define select PINA.0
;      35 #define load_active {PORTD.3=PORTD.5=1; PORTD.4=PORTD.6=0;}
;      36 #define load_clr  {PORTD.3=PORTD.5=0; PORTD.4=PORTD.6=1;}
;      37 #define byte1 PIND.5
;      38 
;      39 unsigned char t=0;
;      40 
;      41 unsigned int temp,temp1=0;
;      42 
;      43 bit flags_button=0;
;      44 bit flags=0;
;      45 bit flags_off_button=0;
;      46 
;      47 typedef unsigned char byte;
;      48 
;      49 byte timer_select=0;
;      50 byte temp_select=0;
;      51 byte sek=0;
;      52 byte timer=0;
;      53 
;      54 byte timer_off_button=0;
;      55 
;      56 //byte flags=0;
;      57 byte led_buff [3];
_led_buff:
	.BYTE 0x3
;      58  /*
;      59 flash byte led_table[17]={   // anode
;      60 0b00000011,                   //0
;      61 0b10011111,                   //1
;      62 0b00100101,                   //2
;      63 0b00001101,                   //3
;      64 0b10011001,                   //4
;      65 0b01001001,                   //5
;      66 0b01000001,                   //6
;      67 0b00011111,                   //7
;      68 0b00000001,                   //8
;      69 0b00001001,                   //9
;      70 0b11111101,                   // 
;      71 0b11111111,                   //
;      72 0b11100011,                   // L
;      73 0b11100001,                   // t
;      74 0b01110001,                   // F
;      75 0b11110101,                   // r
;      76 0b01100001                    // E
;      77 } ;   */
;      78 
;      79 flash byte led_table[17]={     // chatode

	.CSEG
;      80 0b11111100,                   //0
;      81 0b01100000,                   //1
;      82 0b11011010,                   //2
;      83 0b11110010,                   //3
;      84 0b01100110,                   //4
;      85 0b10110110,                   //5
;      86 0b10111110,                   //6
;      87 0b11100000,                   //7
;      88 0b11111110,                   //8
;      89 0b11110110,                   //9
;      90 0b00000010,                   // 
;      91 0b00000000,                   //
;      92 0b00011100,                   // L
;      93 0b00011110,                   // t
;      94 0b10001110,                   // F
;      95 0b00001010,                   // r
;      96 0b10011110                    // E
;      97 } ;
;      98 
;      99 
;     100 // Timer 0 overflow interrupt service routine
;     101 interrupt [TIM0_OVF] void timer0_ovf_isr(void)
;     102 {
_timer0_ovf_isr:
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
;     103 // Reinitialize Timer 0 value
;     104 TCNT0=0x9F; // 105
	LDI  R30,LOW(159)
	OUT  0x32,R30
;     105 // Place your code here
;     106 PORTD.0=1;
	SBI  0x12,0
;     107 PORTD.1=1;
	SBI  0x12,1
;     108 PORTD.2=1;
	SBI  0x12,2
;     109 switch (t)
	MOV  R30,R3
;     110 {
;     111 case 0:
	CPI  R30,0
	BRNE _0xC
;     112 PORTD.2=0;
	CBI  0x12,2
;     113 
;     114 PORTB = led_buff [0];
	LDS  R30,_led_buff
	RJMP _0x78
;     115 break;
;     116 
;     117 case 1:
_0xC:
	CPI  R30,LOW(0x1)
	BRNE _0xF
;     118 PORTD.1=0;
	CBI  0x12,1
;     119 
;     120 PORTB = led_buff [1];
	__GETB1MN _led_buff,1
	RJMP _0x78
;     121 break;
;     122 
;     123 case 2:
_0xF:
	CPI  R30,LOW(0x2)
	BRNE _0xB
;     124 PORTD.0=0;
	CBI  0x12,0
;     125 
;     126 PORTB = led_buff [2];
	__GETB1MN _led_buff,2
_0x78:
	OUT  0x18,R30
;     127 break;
;     128 }
_0xB:
;     129  t++;
	INC  R3
;     130 if (t>2) t=0;
	LDI  R30,LOW(2)
	CP   R30,R3
	BRSH _0x15
	CLR  R3
;     131 }
_0x15:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;     132 
;     133 // Declare your global variables here
;     134 
;     135 void main(void)
;     136 {
_main:
;     137 // Declare your local variables here
;     138 
;     139 // Crystal Oscillator division factor: 1
;     140 #pragma optsize-
;     141 CLKPR=0x80;
	LDI  R30,LOW(128)
	OUT  0x26,R30
;     142 CLKPR=0x00;
	LDI  R30,LOW(0)
	OUT  0x26,R30
;     143 #ifdef _OPTIMIZE_SIZE_
;     144 #pragma optsize+
;     145 #endif
;     146 
;     147 // Input/Output Ports initialization
;     148 // Port A initialization
;     149 // Func2=Out Func1=In Func0=In
;     150 // State2=0 State1=P State0=P
;     151 PORTA=0x03;
	LDI  R30,LOW(3)
	OUT  0x1B,R30
;     152 DDRA=0x04;
	LDI  R30,LOW(4)
	OUT  0x1A,R30
;     153 
;     154 // Port B initialization
;     155 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
;     156 // State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
;     157 PORTB=0x00;
	LDI  R30,LOW(0)
	OUT  0x18,R30
;     158 DDRB=0xFF;
	LDI  R30,LOW(255)
	OUT  0x17,R30
;     159 
;     160 // Port D initialization
;     161 // Func6=Out Func5=In Func4=In Func3=In Func2=Out Func1=Out Func0=Out
;     162 // State6=0 State5=P State4=P State3=P State2=0 State1=0 State0=0
;     163 PORTD=0b1010000;
	LDI  R30,LOW(80)
	OUT  0x12,R30
;     164 DDRD=0b1111111;
	LDI  R30,LOW(127)
	OUT  0x11,R30
;     165 
;     166 
;     167 
;     168 // Timer/Counter 0 initialization
;     169 // Clock source: System Clock
;     170 // Clock value: 7,813 kHz
;     171 // Mode: Normal top=FFh
;     172 // OC0A output: Disconnected
;     173 // OC0B output: Disconnected
;     174 TCCR0A=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
;     175 TCCR0B=0x04;
	LDI  R30,LOW(4)
	OUT  0x33,R30
;     176 TCNT0=0x9F;  //  159    //  068
	LDI  R30,LOW(159)
	OUT  0x32,R30
;     177 OCR0A=0x00;
	LDI  R30,LOW(0)
	OUT  0x36,R30
;     178 OCR0B=0x00;
	OUT  0x3C,R30
;     179 
;     180 // Timer/Counter 1 initialization
;     181 // Clock source: System Clock
;     182 // Clock value: Timer 1 Stopped
;     183 // Mode: Normal top=FFFFh
;     184 // OC1A output: Discon.
;     185 // OC1B output: Discon.
;     186 // Noise Canceler: Off
;     187 // Input Capture on Falling Edge
;     188 // Timer 1 Overflow Interrupt: Off
;     189 // Input Capture Interrupt: Off
;     190 // Compare A Match Interrupt: Off
;     191 // Compare B Match Interrupt: Off
;     192 TCCR1A=0x00;
	OUT  0x2F,R30
;     193 TCCR1B=0x00;
	OUT  0x2E,R30
;     194 TCNT1H=0x00;
	OUT  0x2D,R30
;     195 TCNT1L=0x00;
	OUT  0x2C,R30
;     196 ICR1H=0x00;
	OUT  0x25,R30
;     197 ICR1L=0x00;
	OUT  0x24,R30
;     198 OCR1AH=0x00;
	OUT  0x2B,R30
;     199 OCR1AL=0x00;
	OUT  0x2A,R30
;     200 OCR1BH=0x00;
	OUT  0x29,R30
;     201 OCR1BL=0x00;
	OUT  0x28,R30
;     202 
;     203 // External Interrupt(s) initialization
;     204 // INT0: Off
;     205 // INT1: Off
;     206 // Interrupt on any change on pins PCINT0-7: Off
;     207 GIMSK=0x00;
	OUT  0x3B,R30
;     208 MCUCR=0x00;
	OUT  0x35,R30
;     209 
;     210 // Timer(s)/Counter(s) Interrupt(s) initialization
;     211 TIMSK=0x02;
	LDI  R30,LOW(2)
	OUT  0x39,R30
;     212 
;     213 // Universal Serial Interface initialization
;     214 // Mode: Disabled
;     215 // Clock source: Register & Counter=no clk.
;     216 // USI Counter Overflow Interrupt: Off
;     217 USICR=0x00;
	LDI  R30,LOW(0)
	OUT  0xD,R30
;     218 
;     219 // Analog Comparator initialization
;     220 // Analog Comparator: Off
;     221 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     222 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     223 
;     224 // Global enable interrupts
;     225 #asm("sei")
	sei
;     226 
;     227 while (1)
_0x16:
;     228       {
;     229       // Place your code here
;     230 
;     231        if (start==0 && flags_button==0)
	SBIC 0x19,1
	RJMP _0x1A
	SBIS 0x13,0
	RJMP _0x1B
_0x1A:
	RJMP _0x19
_0x1B:
;     232         {
;     233          delay_ms(50);
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     234            if (start==0 && flags_button==0)
	SBIC 0x19,1
	RJMP _0x1D
	SBIS 0x13,0
	RJMP _0x1E
_0x1D:
	RJMP _0x1C
_0x1E:
;     235             {
;     236              if (flags) flags=0; else flags=1;
	SBIS 0x13,1
	RJMP _0x1F
	CBI  0x13,1
	RJMP _0x22
_0x1F:
	SBI  0x13,1
;     237 
;     238              flags_button=1;
_0x22:
	SBI  0x13,0
;     239             }
;     240         }
_0x1C:
;     241 
;     242         if (select==0 && flags_button==0)
_0x19:
	SBIC 0x19,0
	RJMP _0x28
	SBIS 0x13,0
	RJMP _0x29
_0x28:
	RJMP _0x27
_0x29:
;     243         {
;     244          delay_ms(50);
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     245          if (select==0 && flags_button==0)
	SBIC 0x19,0
	RJMP _0x2B
	SBIS 0x13,0
	RJMP _0x2C
_0x2B:
	RJMP _0x2A
_0x2C:
;     246           {
;     247             timer_off_button++;
	INC  R10
;     248 
;     249              if (timer_off_button > 15)
	LDI  R30,LOW(15)
	CP   R30,R10
	BRSH _0x2D
;     250               {
;     251 
;     252                timer_select=0;
	CLR  R2
;     253                flags_off_button=0;
	CBI  0x13,2
;     254                timer_off_button=0;
	CLR  R10
;     255                flags_button=1;
	SBI  0x13,0
;     256               }
;     257                else
	RJMP _0x32
_0x2D:
;     258                {
;     259                 flags_off_button=1;
	SBI  0x13,2
;     260 
;     261                }
_0x32:
;     262 
;     263           }
;     264 
;     265         }
_0x2A:
;     266 
;     267 
;     268 
;     269         if (start && select)
_0x27:
	SBIS 0x19,1
	RJMP _0x36
	SBIC 0x19,0
	RJMP _0x37
_0x36:
	RJMP _0x35
_0x37:
;     270         {
;     271          flags_button=0;
	CBI  0x13,0
;     272             if(flags_off_button==1)
	SBIS 0x13,2
	RJMP _0x3A
;     273          {
;     274           if ( timer_select++ == 7 ) {timer_select=0;}
	MOV  R30,R2
	INC  R2
	CPI  R30,LOW(0x7)
	BRNE _0x3B
	CLR  R2
;     275             flags=0;
_0x3B:
	CBI  0x13,1
;     276             temp1=0;
	CLR  R6
	CLR  R7
;     277             timer_off_button=0;
	CLR  R10
;     278             flags_off_button=0;
	CBI  0x13,2
;     279 
;     280          }
;     281 
;     282         }
_0x3A:
;     283 
;     284         if (timer_select == 0)
_0x35:
	TST  R2
	BRNE _0x40
;     285          {
;     286             led_buff[2]=led_table[14]; //  
	__POINTW1FN _led_table,14
	LPM  R0,Z
	__PUTBR0MN _led_buff,2
;     287             led_buff[1]=led_table[14];
	__POINTW1FN _led_table,14
	LPM  R0,Z
	__PUTBR0MN _led_buff,1
;     288             led_buff[0]=led_table[0];
	LDI  R30,LOW(_led_table*2)
	LDI  R31,HIGH(_led_table*2)
	LPM  R30,Z
	LDI  R26,LOW(_led_buff)
	ST   X,R30
;     289 
;     290              load_clr;
	LDI  R30,LOW(0)
	CPI  R30,0
	BRNE _0x41
	CBI  0x12,5
	RJMP _0x42
_0x41:
	SBI  0x12,5
_0x42:
	CPI  R30,0
	BRNE _0x43
	CBI  0x12,3
	RJMP _0x44
_0x43:
	SBI  0x12,3
_0x44:
	LDI  R30,LOW(1)
	CPI  R30,0
	BRNE _0x45
	CBI  0x12,6
	RJMP _0x46
_0x45:
	SBI  0x12,6
_0x46:
	CPI  R30,0
	BRNE _0x47
	CBI  0x12,4
	RJMP _0x48
_0x47:
	SBI  0x12,4
_0x48:
;     291 
;     292          } else if (timer_select == 1)
	RJMP _0x49
_0x40:
	LDI  R30,LOW(1)
	CP   R30,R2
	BRNE _0x4A
;     293             {
;     294                temp_select=10;
	LDI  R30,LOW(10)
	MOV  R9,R30
;     295             } else if (timer_select == 2)
	RJMP _0x4B
_0x4A:
	LDI  R30,LOW(2)
	CP   R30,R2
	BRNE _0x4C
;     296                {
;     297                   temp_select=20;
	LDI  R30,LOW(20)
	MOV  R9,R30
;     298                } else if (timer_select == 3)
	RJMP _0x4D
_0x4C:
	LDI  R30,LOW(3)
	CP   R30,R2
	BRNE _0x4E
;     299                   {
;     300                      temp_select=30;
	LDI  R30,LOW(30)
	MOV  R9,R30
;     301                   } else if (timer_select == 4)
	RJMP _0x4F
_0x4E:
	LDI  R30,LOW(4)
	CP   R30,R2
	BRNE _0x50
;     302                      {
;     303                         temp_select=40;
	LDI  R30,LOW(40)
	MOV  R9,R30
;     304                      } else if (timer_select == 5)
	RJMP _0x51
_0x50:
	LDI  R30,LOW(5)
	CP   R30,R2
	BRNE _0x52
;     305                         {
;     306                            temp_select=50;
	LDI  R30,LOW(50)
	MOV  R9,R30
;     307                         } else if (timer_select == 6)
	RJMP _0x53
_0x52:
	LDI  R30,LOW(6)
	CP   R30,R2
	BRNE _0x54
;     308                            {
;     309                             temp_select=60;
	LDI  R30,LOW(60)
	MOV  R9,R30
;     310                            } else if (timer_select == 7)
	RJMP _0x55
_0x54:
	LDI  R30,LOW(7)
	CP   R30,R2
	BRNE _0x56
;     311                               {
;     312                                timer_select=0;
	CLR  R2
;     313                               }
;     314 
;     315           if (timer_select!=0)
_0x56:
_0x55:
_0x53:
_0x51:
_0x4F:
_0x4D:
_0x4B:
_0x49:
	TST  R2
	BRNE PC+2
	RJMP _0x57
;     316          {
;     317            if (temp1<10)
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CP   R6,R30
	CPC  R7,R31
	BRSH _0x58
;     318           {
;     319 
;     320            led_buff[2]=led_table[temp]; //  
	MOVW R30,R4
	SUBI R30,LOW(-_led_table*2)
	SBCI R31,HIGH(-_led_table*2)
	LPM  R0,Z
	__PUTBR0MN _led_buff,2
;     321 
;     322            led_buff[1]=led_table[11];
	__POINTW1FN _led_table,11
	LPM  R0,Z
	__PUTBR0MN _led_buff,1
;     323 
;     324            led_buff[0]=led_table[13];
	__POINTW1FN _led_table,13
	LPM  R30,Z
	LDI  R26,LOW(_led_buff)
	ST   X,R30
;     325           }
;     326 
;     327            if (temp1>9 && temp1<100)
_0x58:
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	CP   R30,R6
	CPC  R31,R7
	BRSH _0x5A
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CP   R6,R30
	CPC  R7,R31
	BRLO _0x5B
_0x5A:
	RJMP _0x59
_0x5B:
;     328           {
;     329            led_buff[2]=led_table[temp%10]; //  
	MOVW R26,R4
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21U
	SUBI R30,LOW(-_led_table*2)
	SBCI R31,HIGH(-_led_table*2)
	LPM  R0,Z
	__PUTBR0MN _led_buff,2
;     330            temp=temp/10;
	MOVW R26,R4
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21U
	MOVW R4,R30
;     331            led_buff[1]=led_table[temp%10];
	MOVW R26,R4
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21U
	SUBI R30,LOW(-_led_table*2)
	SBCI R31,HIGH(-_led_table*2)
	LPM  R0,Z
	__PUTBR0MN _led_buff,1
;     332 
;     333            led_buff[0]=led_table[13];
	__POINTW1FN _led_table,13
	LPM  R30,Z
	LDI  R26,LOW(_led_buff)
	ST   X,R30
;     334           }
;     335              if (flags)
_0x59:
	SBIS 0x13,1
	RJMP _0x5C
;     336               {
;     337 
;     338                if (sek==0){sek=temp_select; flags=0;}
	TST  R8
	BRNE _0x5D
	MOV  R8,R9
	CBI  0x13,1
;     339                if(timer>0){timer--;} else{ timer=50; sek--;}
_0x5D:
	LDI  R30,LOW(0)
	CP   R30,R11
	BRSH _0x60
	DEC  R11
	RJMP _0x61
_0x60:
	LDI  R30,LOW(50)
	MOV  R11,R30
	DEC  R8
_0x61:
;     340                temp1=sek;
	MOV  R6,R8
	CLR  R7
;     341 
;     342                load_active;
	LDI  R30,LOW(1)
	CPI  R30,0
	BRNE _0x62
	CBI  0x12,5
	RJMP _0x63
_0x62:
	SBI  0x12,5
_0x63:
	CPI  R30,0
	BRNE _0x64
	CBI  0x12,3
	RJMP _0x65
_0x64:
	SBI  0x12,3
_0x65:
	LDI  R30,LOW(0)
	CPI  R30,0
	BRNE _0x66
	CBI  0x12,6
	RJMP _0x67
_0x66:
	SBI  0x12,6
_0x67:
	CPI  R30,0
	BRNE _0x68
	CBI  0x12,4
	RJMP _0x69
_0x68:
	SBI  0x12,4
_0x69:
;     343 
;     344               }
;     345                else
	RJMP _0x6A
_0x5C:
;     346               {
;     347                if(temp1<temp_select){temp1++;} else{ temp1=temp_select; flags=0;}
	MOV  R30,R9
	MOVW R26,R6
	LDI  R31,0
	CP   R26,R30
	CPC  R27,R31
	BRSH _0x6B
	MOVW R30,R6
	ADIW R30,1
	MOVW R6,R30
	SBIW R30,1
	RJMP _0x6C
_0x6B:
	MOV  R6,R9
	CLR  R7
	CBI  0x13,1
_0x6C:
;     348                sek=temp_select;
	MOV  R8,R9
;     349 
;     350                load_clr;
	LDI  R30,LOW(0)
	CPI  R30,0
	BRNE _0x6F
	CBI  0x12,5
	RJMP _0x70
_0x6F:
	SBI  0x12,5
_0x70:
	CPI  R30,0
	BRNE _0x71
	CBI  0x12,3
	RJMP _0x72
_0x71:
	SBI  0x12,3
_0x72:
	LDI  R30,LOW(1)
	CPI  R30,0
	BRNE _0x73
	CBI  0x12,6
	RJMP _0x74
_0x73:
	SBI  0x12,6
_0x74:
	CPI  R30,0
	BRNE _0x75
	CBI  0x12,4
	RJMP _0x76
_0x75:
	SBI  0x12,4
_0x76:
;     351               }
_0x6A:
;     352          }
;     353 
;     354 
;     355 
;     356 
;     357 
;     358 
;     359 
;     360 
;     361         delay_ms(20);
_0x57:
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     362 
;     363        temp = temp1;
	MOVW R4,R6
;     364 
;     365 
;     366 
;     367       };
	RJMP _0x16
;     368 }
_0x77:
	RJMP _0x77


_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__MODW21U:
	RCALL __DIVW21U
	MOVW R30,R26
	RET

;END OF CODE MARKER
__END_OF_CODE:
