
#pragma used+
sfrb DIDR=1;
sfrb UBRRH=2;
sfrb UCSRC=3;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb USICR=0xd;
sfrb USISR=0xe;
sfrb USIDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb GPIOR0=0x13;
sfrb GPIOR1=0x14;
sfrb GPIOR2=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEAR=0x1e;
sfrb PCMSK=0x20;
sfrb WDTCR=0x21;
sfrb TCCR1C=0x22;
sfrb GTCCR=0x23;
sfrb ICR1L=0x24;
sfrb ICR1H=0x25;
sfrw ICR1=0x24;   
sfrb CLKPR=0x26;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;   
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;   
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb TCCR0A=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0B=0x33;
sfrb MCUSR=0x34;
sfrb MCUCR=0x35;
sfrb OCR0A=0x36;
sfrb SPMCSR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb EIFR=0x3a;
sfrb GIMSK=0x3b;
sfrb OCR0B=0x3c;
sfrb SPL=0x3d;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x50
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x40
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

unsigned char t=0; 

unsigned int temp,temp1=0;

bit flags_button=0;
bit flags=0;
bit flags_off_button=0;

typedef unsigned char byte;

byte timer_select=0;
byte temp_select=0;
byte sek=0;
byte timer=0;                                

byte timer_off_button=0; 

byte led_buff [3];

flash byte led_table[18]={     
0b11111100,                   
0b01100000,                   
0b11011010,                   
0b11110010,                   
0b01100110,                   
0b10110110,                   
0b10111110,                   
0b11100000,                   
0b11111110,                   
0b11110110,                   
0b00000010,                   
0b00000000,                   
0b00011100,                   
0b00011110,                   
0b10001110,                   
0b00001010,                   
0b10011110,                   
0b01101110                    
} ;

interrupt [7] void timer0_ovf_isr(void)
{

TCNT0=0x9F; 

PORTD.0=1;
PORTD.1=1;
PORTD.2=1;
switch (t)
{
case 0:
PORTD.2=0;

PORTB = led_buff [0];
break;

case 1:
PORTD.1=0;

PORTB = led_buff [1];
break; 

case 2:
PORTD.0=0;

PORTB = led_buff [2];
break;
}
t++;
if (t>2) t=0;
}

void main(void)
{

#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;

PORTA=0x03;
DDRA=0x04;

PORTB=0x00;
DDRB=0xFF;

PORTD=0b1010000;
DDRD=0b1111111;

TCCR0A=0x00;
TCCR0B=0x04;  
TCNT0=0x9F;  
OCR0A=0x00;
OCR0B=0x00;

TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

GIMSK=0x00;
MCUCR=0x00;

TIMSK=0x02;

USICR=0x00;

ACSR=0x80;

#asm("sei")

led_buff[0]=led_table[11]; 
led_buff[1]=led_table[11];
led_buff[2]=led_table[11];

delay_ms(120);
led_buff[0]=led_table[11]; 
led_buff[1]=led_table[11]; 
led_buff[2]=led_table[17];

delay_ms(120);
led_buff[0]=led_table[11]; 
led_buff[1]=led_table[17]; 
led_buff[2]=led_table[1];

delay_ms(120);
led_buff[0]=led_table[17]; 
led_buff[1]=led_table[1]; 
led_buff[2]=led_table[11];

delay_ms(1000);

led_buff[0]=led_table[11]; 
led_buff[1]=led_table[11]; 
led_buff[2]=led_table[11];

delay_ms(500);
led_buff[0]=led_table[17]; 
led_buff[1]=led_table[1]; 
led_buff[2]=led_table[11];

delay_ms(500);

led_buff[0]=led_table[11]; 
led_buff[1]=led_table[11]; 
led_buff[2]=led_table[11];

delay_ms(500);
led_buff[0]=led_table[17]; 
led_buff[1]=led_table[1]; 
led_buff[2]=led_table[11];

delay_ms(500);

led_buff[0]=led_table[11]; 
led_buff[1]=led_table[11]; 
led_buff[2]=led_table[11];

delay_ms(500);
led_buff[0]=led_table[17]; 
led_buff[1]=led_table[1]; 
led_buff[2]=led_table[11];

delay_ms(750);

led_buff[0]=led_table[11]; 
led_buff[1]=led_table[17]; 
led_buff[2]=led_table[1];

delay_ms(120);
led_buff[0]=led_table[11]; 
led_buff[1]=led_table[11]; 
led_buff[2]=led_table[17];

delay_ms(120);
led_buff[0]=led_table[11]; 
led_buff[1]=led_table[11]; 
led_buff[2]=led_table[11];

delay_ms(400);

while (1)
{

if (PINA.1==0 && flags_button==0)
{
delay_ms(50);
if (PINA.1==0 && flags_button==0)
{
if (flags) flags=0; else flags=1;

flags_button=1;
}
}

if (PINA.0==0 && flags_button==0)
{
delay_ms(50);
if (PINA.0==0 && flags_button==0)
{
timer_off_button++;

if (timer_off_button > 15)
{

timer_select=0;
flags_off_button=0;
timer_off_button=0;
flags_button=1;
}
else
{
flags_off_button=1;

}

}  

} 

if (PINA.1 && PINA.0)
{
flags_button=0;
if(flags_off_button==1)
{
if ( timer_select++ == 7 ) {timer_select=0;}
flags=0;
temp1=0;
timer_off_button=0;
flags_off_button=0;

}

}

if (timer_select == 0)
{
led_buff[2]=led_table[14]; 
led_buff[1]=led_table[14];
led_buff[0]=led_table[0];

{PORTD.3=PORTD.5=0; PORTD.4=PORTD.6=1;};

} else if (timer_select == 1)
{
temp_select=10;
} else if (timer_select == 2)
{
temp_select=20;
} else if (timer_select == 3)
{
temp_select=30;
} else if (timer_select == 4)
{
temp_select=40;
} else if (timer_select == 5)
{
temp_select=50;
} else if (timer_select == 6)
{ 
temp_select=60;
} else if (timer_select == 7)
{
timer_select=0;
}

if (timer_select!=0)
{
if (temp1<10)
{

led_buff[2]=led_table[temp]; 

led_buff[1]=led_table[11];

led_buff[0]=led_table[13];
}

if (temp1>9 && temp1<100)
{
led_buff[2]=led_table[temp%10]; 
temp=temp/10;
led_buff[1]=led_table[temp%10];

led_buff[0]=led_table[13];
}
if (flags)
{

if (sek==0){sek=temp_select; flags=0;}
if(timer>0){timer--;} else{ timer=50; sek--;}
temp1=sek;

{PORTD.3=PORTD.5=1; PORTD.4=PORTD.6=0;};

} 
else
{
if(temp1<temp_select){temp1++;} else{ temp1=temp_select; flags=0;}
sek=temp_select;

{PORTD.3=PORTD.5=0; PORTD.4=PORTD.6=1;};
}
}

delay_ms(20);

temp = temp1;

};
}
