
;CodeVisionAVR C Compiler V2.03.4 Standard
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATtiny2313
;Clock frequency        : 8,000000 MHz
;Memory model           : Tiny
;Optimize for           : Speed
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 32 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;global const stored in FLASH  : No
;8 bit enums            : Yes
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATtiny2313
	#pragma AVRPART MEMORY PROG_FLASH 2048
	#pragma AVRPART MEMORY EEPROM 128
	#pragma AVRPART MEMORY INT_SRAM SIZE 128
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU WDTCR=0x21
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SREG=0x3F
	.EQU GPIOR0=0x13
	.EQU GPIOR1=0x14
	.EQU GPIOR2=0x15

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _t=R3
	.DEF _temp=R4
	.DEF _temp1=R6
	.DEF _timer_select=R2
	.DEF _temp_select=R9
	.DEF _sek=R8
	.DEF _timer=R11
	.DEF _timer_off_button=R10

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer0_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_led_table:
	.DB  0xFC,0x60,0xDA,0xF2,0x66,0xB6,0xBE,0xE0
	.DB  0xFE,0xF6,0x2,0x0,0x1C,0x1E,0x8E,0xA
	.DB  0x9E,0x6E

;GPIOR0-GPIOR2 INITIALIZATION
	.EQU  __GPIOR0_INIT=0x00
	.EQU  __GPIOR1_INIT=0x00
	.EQU  __GPIOR2_INIT=0x00

_0x79:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0

__GLOBAL_INI_TBL:
	.DW  0x0A
	.DW  0x02
	.DW  _0x79*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x80)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0-GPIOR2 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30
	LDI  R30,__GPIOR1_INIT
	OUT  GPIOR1,R30
	LDI  R30,__GPIOR2_INIT
	OUT  GPIOR2,R30

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0xDF)
	OUT  SPL,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x80)
	LDI  R29,HIGH(0x80)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x80

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V1.25.8 Standard
;Automatic Program Generator
; Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 27.06.2011
;Author  : F4CG
;Company : F4CG
;Comments:
;
;
;Chip type           : ATtiny2313
;Clock frequency     : 8,000000 MHz
;Memory model        : Tiny
;External SRAM size  : 0
;Data Stack size     : 32
;*****************************************************/
;
;#include <tiny2313.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x50
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x40
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#define start PINA.1
;#define select PINA.0
;#define load_active {PORTD.3=PORTD.5=1; PORTD.4=PORTD.6=0;}
;#define load_clr  {PORTD.3=PORTD.5=0; PORTD.4=PORTD.6=1;}
;#define byte1 PIND.5
;#define delay_table 120
;
;unsigned char t=0;
;
;unsigned int temp,temp1=0;
;
;bit flags_button=0;
;bit flags=0;
;bit flags_off_button=0;
;
;typedef unsigned char byte;
;
;byte timer_select=0;
;byte temp_select=0;
;byte sek=0;
;byte timer=0;
;
;byte timer_off_button=0;
;
;//byte flags=0;
;byte led_buff [3];
; /*
;flash byte led_table[17]={   // anode
;0b00000011,                   //0
;0b10011111,                   //1
;0b00100101,                   //2
;0b00001101,                   //3
;0b10011001,                   //4
;0b01001001,                   //5
;0b01000001,                   //6
;0b00011111,                   //7
;0b00000001,                   //8
;0b00001001,                   //9
;0b11111101,                   // 
;0b11111111,                   //
;0b11100011,                   // L
;0b11100001,                   // t
;0b01110001,                   // F
;0b11110101,                   // r
;0b01100001                    // E
;} ;   */
;
;flash byte led_table[18]={     // chatode
;0b11111100,                   //0
;0b01100000,                   //1
;0b11011010,                   //2
;0b11110010,                   //3
;0b01100110,                   //4
;0b10110110,                   //5
;0b10111110,                   //6
;0b11100000,                   //7
;0b11111110,                   //8
;0b11110110,                   //9
;0b00000010,                   // 
;0b00000000,                   //
;0b00011100,                   // L
;0b00011110,                   // t
;0b10001110,                   // F
;0b00001010,                   // r
;0b10011110,                   // E
;0b01101110                    // H
;} ;
;
;
;// Timer 0 overflow interrupt service routine
;interrupt [TIM0_OVF] void timer0_ovf_isr(void)
; 0000 0060 {

	.CSEG
_timer0_ovf_isr:
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
; 0000 0061 // Reinitialize Timer 0 value
; 0000 0062 TCNT0=0x9F; // 105
	LDI  R30,LOW(159)
	OUT  0x32,R30
; 0000 0063 // Place your code here
; 0000 0064 PORTD.0=1;
	SBI  0x12,0
; 0000 0065 PORTD.1=1;
	SBI  0x12,1
; 0000 0066 PORTD.2=1;
	SBI  0x12,2
; 0000 0067 switch (t)
	MOV  R30,R3
; 0000 0068 {
; 0000 0069 case 0:
	CPI  R30,0
	BRNE _0xC
; 0000 006A PORTD.2=0;
	CBI  0x12,2
; 0000 006B 
; 0000 006C PORTB = led_buff [0];
	LDS  R30,_led_buff
	RJMP _0x78
; 0000 006D break;
; 0000 006E 
; 0000 006F case 1:
_0xC:
	CPI  R30,LOW(0x1)
	BRNE _0xF
; 0000 0070 PORTD.1=0;
	CBI  0x12,1
; 0000 0071 
; 0000 0072 PORTB = led_buff [1];
	__GETB1MN _led_buff,1
	RJMP _0x78
; 0000 0073 break;
; 0000 0074 
; 0000 0075 case 2:
_0xF:
	CPI  R30,LOW(0x2)
	BRNE _0xB
; 0000 0076 PORTD.0=0;
	CBI  0x12,0
; 0000 0077 
; 0000 0078 PORTB = led_buff [2];
	__GETB1MN _led_buff,2
_0x78:
	OUT  0x18,R30
; 0000 0079 break;
; 0000 007A }
_0xB:
; 0000 007B  t++;
	INC  R3
; 0000 007C if (t>2) t=0;
	LDI  R30,LOW(2)
	CP   R30,R3
	BRSH _0x15
	CLR  R3
; 0000 007D }
_0x15:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;
;// Declare your global variables here
;
;void main(void)
; 0000 0082 {
_main:
; 0000 0083 // Declare your local variables here
; 0000 0084 
; 0000 0085 // Crystal Oscillator division factor: 1
; 0000 0086 #pragma optsize-
; 0000 0087 CLKPR=0x80;
	LDI  R30,LOW(128)
	OUT  0x26,R30
; 0000 0088 CLKPR=0x00;
	LDI  R30,LOW(0)
	OUT  0x26,R30
; 0000 0089 #ifdef _OPTIMIZE_SIZE_
; 0000 008A #pragma optsize+
; 0000 008B #endif
; 0000 008C 
; 0000 008D // Input/Output Ports initialization
; 0000 008E // Port A initialization
; 0000 008F // Func2=Out Func1=In Func0=In
; 0000 0090 // State2=0 State1=P State0=P
; 0000 0091 PORTA=0x03;
	LDI  R30,LOW(3)
	OUT  0x1B,R30
; 0000 0092 DDRA=0x04;
	LDI  R30,LOW(4)
	OUT  0x1A,R30
; 0000 0093 
; 0000 0094 // Port B initialization
; 0000 0095 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 0096 // State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
; 0000 0097 PORTB=0x00;
	LDI  R30,LOW(0)
	OUT  0x18,R30
; 0000 0098 DDRB=0xFF;
	LDI  R30,LOW(255)
	OUT  0x17,R30
; 0000 0099 
; 0000 009A // Port D initialization
; 0000 009B // Func6=Out Func5=In Func4=In Func3=In Func2=Out Func1=Out Func0=Out
; 0000 009C // State6=0 State5=P State4=P State3=P State2=0 State1=0 State0=0
; 0000 009D PORTD=0b1010000;
	LDI  R30,LOW(80)
	OUT  0x12,R30
; 0000 009E DDRD=0b1111111;
	LDI  R30,LOW(127)
	OUT  0x11,R30
; 0000 009F 
; 0000 00A0 
; 0000 00A1 
; 0000 00A2 // Timer/Counter 0 initialization
; 0000 00A3 // Clock source: System Clock
; 0000 00A4 // Clock value: 7,813 kHz
; 0000 00A5 // Mode: Normal top=FFh
; 0000 00A6 // OC0A output: Disconnected
; 0000 00A7 // OC0B output: Disconnected
; 0000 00A8 TCCR0A=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 00A9 TCCR0B=0x04;
	LDI  R30,LOW(4)
	OUT  0x33,R30
; 0000 00AA TCNT0=0x9F;  //  159    //  068
	LDI  R30,LOW(159)
	OUT  0x32,R30
; 0000 00AB OCR0A=0x00;
	LDI  R30,LOW(0)
	OUT  0x36,R30
; 0000 00AC OCR0B=0x00;
	OUT  0x3C,R30
; 0000 00AD 
; 0000 00AE // Timer/Counter 1 initialization
; 0000 00AF // Clock source: System Clock
; 0000 00B0 // Clock value: Timer 1 Stopped
; 0000 00B1 // Mode: Normal top=FFFFh
; 0000 00B2 // OC1A output: Discon.
; 0000 00B3 // OC1B output: Discon.
; 0000 00B4 // Noise Canceler: Off
; 0000 00B5 // Input Capture on Falling Edge
; 0000 00B6 // Timer 1 Overflow Interrupt: Off
; 0000 00B7 // Input Capture Interrupt: Off
; 0000 00B8 // Compare A Match Interrupt: Off
; 0000 00B9 // Compare B Match Interrupt: Off
; 0000 00BA TCCR1A=0x00;
	OUT  0x2F,R30
; 0000 00BB TCCR1B=0x00;
	OUT  0x2E,R30
; 0000 00BC TCNT1H=0x00;
	OUT  0x2D,R30
; 0000 00BD TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 00BE ICR1H=0x00;
	OUT  0x25,R30
; 0000 00BF ICR1L=0x00;
	OUT  0x24,R30
; 0000 00C0 OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 00C1 OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 00C2 OCR1BH=0x00;
	OUT  0x29,R30
; 0000 00C3 OCR1BL=0x00;
	OUT  0x28,R30
; 0000 00C4 
; 0000 00C5 // External Interrupt(s) initialization
; 0000 00C6 // INT0: Off
; 0000 00C7 // INT1: Off
; 0000 00C8 // Interrupt on any change on pins PCINT0-7: Off
; 0000 00C9 GIMSK=0x00;
	OUT  0x3B,R30
; 0000 00CA MCUCR=0x00;
	OUT  0x35,R30
; 0000 00CB 
; 0000 00CC // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 00CD TIMSK=0x02;
	LDI  R30,LOW(2)
	OUT  0x39,R30
; 0000 00CE 
; 0000 00CF // Universal Serial Interface initialization
; 0000 00D0 // Mode: Disabled
; 0000 00D1 // Clock source: Register & Counter=no clk.
; 0000 00D2 // USI Counter Overflow Interrupt: Off
; 0000 00D3 USICR=0x00;
	LDI  R30,LOW(0)
	OUT  0xD,R30
; 0000 00D4 
; 0000 00D5 // Analog Comparator initialization
; 0000 00D6 // Analog Comparator: Off
; 0000 00D7 // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 00D8 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 00D9 
; 0000 00DA // Global enable interrupts
; 0000 00DB #asm("sei")
	sei
; 0000 00DC 
; 0000 00DD 
; 0000 00DE         led_buff[0]=led_table[11]; //  HELLO
	__POINTW1FN _led_table,11
	LPM  R0,Z
	STS  _led_buff,R0
; 0000 00DF         led_buff[1]=led_table[11];
	__POINTW1FN _led_table,11
	LPM  R0,Z
	__PUTBR0MN _led_buff,1
; 0000 00E0         led_buff[2]=led_table[11];
	__POINTW1FN _led_table,11
	LPM  R0,Z
	__PUTBR0MN _led_buff,2
; 0000 00E1 
; 0000 00E2         delay_ms(delay_table);
	LDI  R30,LOW(120)
	LDI  R31,HIGH(120)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 00E3         led_buff[0]=led_table[11]; //  
	__POINTW1FN _led_table,11
	LPM  R0,Z
	STS  _led_buff,R0
; 0000 00E4         led_buff[1]=led_table[11]; //  HELLO
	__POINTW1FN _led_table,11
	LPM  R0,Z
	__PUTBR0MN _led_buff,1
; 0000 00E5         led_buff[2]=led_table[17];
	__POINTW1FN _led_table,17
	LPM  R0,Z
	__PUTBR0MN _led_buff,2
; 0000 00E6 
; 0000 00E7         delay_ms(delay_table);
	LDI  R30,LOW(120)
	LDI  R31,HIGH(120)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 00E8         led_buff[0]=led_table[11]; //  
	__POINTW1FN _led_table,11
	LPM  R0,Z
	STS  _led_buff,R0
; 0000 00E9         led_buff[1]=led_table[17]; //  HELLO
	__POINTW1FN _led_table,17
	LPM  R0,Z
	__PUTBR0MN _led_buff,1
; 0000 00EA         led_buff[2]=led_table[1];
	__POINTW1FN _led_table,1
	LPM  R0,Z
	__PUTBR0MN _led_buff,2
; 0000 00EB 
; 0000 00EC          delay_ms(delay_table);
	LDI  R30,LOW(120)
	LDI  R31,HIGH(120)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 00ED         led_buff[0]=led_table[17]; //  
	__POINTW1FN _led_table,17
	LPM  R0,Z
	STS  _led_buff,R0
; 0000 00EE         led_buff[1]=led_table[1]; //  HELLO
	__POINTW1FN _led_table,1
	LPM  R0,Z
	__PUTBR0MN _led_buff,1
; 0000 00EF         led_buff[2]=led_table[11];
	__POINTW1FN _led_table,11
	LPM  R0,Z
	__PUTBR0MN _led_buff,2
; 0000 00F0 
; 0000 00F1 
; 0000 00F2          delay_ms(1000);
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 00F3 
; 0000 00F4         led_buff[0]=led_table[11]; //  
	__POINTW1FN _led_table,11
	LPM  R0,Z
	STS  _led_buff,R0
; 0000 00F5         led_buff[1]=led_table[11]; //  HELLO
	__POINTW1FN _led_table,11
	LPM  R0,Z
	__PUTBR0MN _led_buff,1
; 0000 00F6         led_buff[2]=led_table[11];
	__POINTW1FN _led_table,11
	LPM  R0,Z
	__PUTBR0MN _led_buff,2
; 0000 00F7 
; 0000 00F8         delay_ms(500);
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 00F9         led_buff[0]=led_table[17]; //  
	__POINTW1FN _led_table,17
	LPM  R0,Z
	STS  _led_buff,R0
; 0000 00FA         led_buff[1]=led_table[1]; //  HELLO
	__POINTW1FN _led_table,1
	LPM  R0,Z
	__PUTBR0MN _led_buff,1
; 0000 00FB         led_buff[2]=led_table[11];
	__POINTW1FN _led_table,11
	LPM  R0,Z
	__PUTBR0MN _led_buff,2
; 0000 00FC 
; 0000 00FD         delay_ms(500);
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 00FE 
; 0000 00FF         led_buff[0]=led_table[11]; //  
	__POINTW1FN _led_table,11
	LPM  R0,Z
	STS  _led_buff,R0
; 0000 0100         led_buff[1]=led_table[11]; //  HELLO
	__POINTW1FN _led_table,11
	LPM  R0,Z
	__PUTBR0MN _led_buff,1
; 0000 0101         led_buff[2]=led_table[11];
	__POINTW1FN _led_table,11
	LPM  R0,Z
	__PUTBR0MN _led_buff,2
; 0000 0102 
; 0000 0103          delay_ms(500);
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0104         led_buff[0]=led_table[17]; //  
	__POINTW1FN _led_table,17
	LPM  R0,Z
	STS  _led_buff,R0
; 0000 0105         led_buff[1]=led_table[1]; //  HELLO
	__POINTW1FN _led_table,1
	LPM  R0,Z
	__PUTBR0MN _led_buff,1
; 0000 0106         led_buff[2]=led_table[11];
	__POINTW1FN _led_table,11
	LPM  R0,Z
	__PUTBR0MN _led_buff,2
; 0000 0107 
; 0000 0108          delay_ms(500);
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0109 
; 0000 010A         led_buff[0]=led_table[11]; //  
	__POINTW1FN _led_table,11
	LPM  R0,Z
	STS  _led_buff,R0
; 0000 010B         led_buff[1]=led_table[11]; //  HELLO
	__POINTW1FN _led_table,11
	LPM  R0,Z
	__PUTBR0MN _led_buff,1
; 0000 010C         led_buff[2]=led_table[11];
	__POINTW1FN _led_table,11
	LPM  R0,Z
	__PUTBR0MN _led_buff,2
; 0000 010D 
; 0000 010E          delay_ms(500);
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 010F         led_buff[0]=led_table[17]; //  
	__POINTW1FN _led_table,17
	LPM  R0,Z
	STS  _led_buff,R0
; 0000 0110         led_buff[1]=led_table[1]; //  HELLO
	__POINTW1FN _led_table,1
	LPM  R0,Z
	__PUTBR0MN _led_buff,1
; 0000 0111         led_buff[2]=led_table[11];
	__POINTW1FN _led_table,11
	LPM  R0,Z
	__PUTBR0MN _led_buff,2
; 0000 0112 
; 0000 0113         delay_ms(750);
	LDI  R30,LOW(750)
	LDI  R31,HIGH(750)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0114 
; 0000 0115         led_buff[0]=led_table[11]; //  
	__POINTW1FN _led_table,11
	LPM  R0,Z
	STS  _led_buff,R0
; 0000 0116         led_buff[1]=led_table[17]; //  HELLO
	__POINTW1FN _led_table,17
	LPM  R0,Z
	__PUTBR0MN _led_buff,1
; 0000 0117         led_buff[2]=led_table[1];
	__POINTW1FN _led_table,1
	LPM  R0,Z
	__PUTBR0MN _led_buff,2
; 0000 0118 
; 0000 0119         delay_ms(delay_table);
	LDI  R30,LOW(120)
	LDI  R31,HIGH(120)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 011A         led_buff[0]=led_table[11]; //  
	__POINTW1FN _led_table,11
	LPM  R0,Z
	STS  _led_buff,R0
; 0000 011B         led_buff[1]=led_table[11]; //  HELLO
	__POINTW1FN _led_table,11
	LPM  R0,Z
	__PUTBR0MN _led_buff,1
; 0000 011C         led_buff[2]=led_table[17];
	__POINTW1FN _led_table,17
	LPM  R0,Z
	__PUTBR0MN _led_buff,2
; 0000 011D 
; 0000 011E          delay_ms(delay_table);
	LDI  R30,LOW(120)
	LDI  R31,HIGH(120)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 011F         led_buff[0]=led_table[11]; //  
	__POINTW1FN _led_table,11
	LPM  R0,Z
	STS  _led_buff,R0
; 0000 0120         led_buff[1]=led_table[11]; //  HELLO
	__POINTW1FN _led_table,11
	LPM  R0,Z
	__PUTBR0MN _led_buff,1
; 0000 0121         led_buff[2]=led_table[11];
	__POINTW1FN _led_table,11
	LPM  R0,Z
	__PUTBR0MN _led_buff,2
; 0000 0122 
; 0000 0123 
; 0000 0124          delay_ms(400);
	LDI  R30,LOW(400)
	LDI  R31,HIGH(400)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0125 
; 0000 0126 
; 0000 0127 while (1)
_0x16:
; 0000 0128       {
; 0000 0129       // Place your code here
; 0000 012A 
; 0000 012B        if (start==0 && flags_button==0)
	LDI  R26,0
	SBIC 0x19,1
	LDI  R26,1
	CPI  R26,LOW(0x0)
	BRNE _0x1A
	LDI  R26,0
	SBIC 0x13,0
	LDI  R26,1
	CPI  R26,LOW(0x0)
	BREQ _0x1B
_0x1A:
	RJMP _0x19
_0x1B:
; 0000 012C         {
; 0000 012D          delay_ms(50);
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 012E            if (start==0 && flags_button==0)
	LDI  R26,0
	SBIC 0x19,1
	LDI  R26,1
	CPI  R26,LOW(0x0)
	BRNE _0x1D
	LDI  R26,0
	SBIC 0x13,0
	LDI  R26,1
	CPI  R26,LOW(0x0)
	BREQ _0x1E
_0x1D:
	RJMP _0x1C
_0x1E:
; 0000 012F             {
; 0000 0130              if (flags) flags=0; else flags=1;
	SBIS 0x13,1
	RJMP _0x1F
	CBI  0x13,1
	RJMP _0x22
_0x1F:
	SBI  0x13,1
; 0000 0131 
; 0000 0132              flags_button=1;
_0x22:
	SBI  0x13,0
; 0000 0133             }
; 0000 0134         }
_0x1C:
; 0000 0135 
; 0000 0136         if (select==0 && flags_button==0)
_0x19:
	LDI  R26,0
	SBIC 0x19,0
	LDI  R26,1
	CPI  R26,LOW(0x0)
	BRNE _0x28
	LDI  R26,0
	SBIC 0x13,0
	LDI  R26,1
	CPI  R26,LOW(0x0)
	BREQ _0x29
_0x28:
	RJMP _0x27
_0x29:
; 0000 0137         {
; 0000 0138          delay_ms(50);
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0139          if (select==0 && flags_button==0)
	LDI  R26,0
	SBIC 0x19,0
	LDI  R26,1
	CPI  R26,LOW(0x0)
	BRNE _0x2B
	LDI  R26,0
	SBIC 0x13,0
	LDI  R26,1
	CPI  R26,LOW(0x0)
	BREQ _0x2C
_0x2B:
	RJMP _0x2A
_0x2C:
; 0000 013A           {
; 0000 013B             timer_off_button++;
	INC  R10
; 0000 013C 
; 0000 013D              if (timer_off_button > 15)
	LDI  R30,LOW(15)
	CP   R30,R10
	BRSH _0x2D
; 0000 013E               {
; 0000 013F 
; 0000 0140                timer_select=0;
	CLR  R2
; 0000 0141                flags_off_button=0;
	CBI  0x13,2
; 0000 0142                timer_off_button=0;
	CLR  R10
; 0000 0143                flags_button=1;
	SBI  0x13,0
; 0000 0144               }
; 0000 0145                else
	RJMP _0x32
_0x2D:
; 0000 0146                {
; 0000 0147                 flags_off_button=1;
	SBI  0x13,2
; 0000 0148 
; 0000 0149                }
_0x32:
; 0000 014A 
; 0000 014B           }
; 0000 014C 
; 0000 014D         }
_0x2A:
; 0000 014E 
; 0000 014F 
; 0000 0150 
; 0000 0151         if (start && select)
_0x27:
	SBIS 0x19,1
	RJMP _0x36
	SBIC 0x19,0
	RJMP _0x37
_0x36:
	RJMP _0x35
_0x37:
; 0000 0152         {
; 0000 0153          flags_button=0;
	CBI  0x13,0
; 0000 0154             if(flags_off_button==1)
	LDI  R26,0
	SBIC 0x13,2
	LDI  R26,1
	CPI  R26,LOW(0x1)
	BRNE _0x3A
; 0000 0155          {
; 0000 0156           if ( timer_select++ == 7 ) {timer_select=0;}
	MOV  R30,R2
	INC  R2
	CPI  R30,LOW(0x7)
	BRNE _0x3B
	CLR  R2
; 0000 0157             flags=0;
_0x3B:
	CBI  0x13,1
; 0000 0158             temp1=0;
	CLR  R6
	CLR  R7
; 0000 0159             timer_off_button=0;
	CLR  R10
; 0000 015A             flags_off_button=0;
	CBI  0x13,2
; 0000 015B 
; 0000 015C          }
; 0000 015D 
; 0000 015E         }
_0x3A:
; 0000 015F 
; 0000 0160         if (timer_select == 0)
_0x35:
	TST  R2
	BRNE _0x40
; 0000 0161          {
; 0000 0162             led_buff[2]=led_table[14]; //  
	__POINTW1FN _led_table,14
	LPM  R0,Z
	__PUTBR0MN _led_buff,2
; 0000 0163             led_buff[1]=led_table[14];
	__POINTW1FN _led_table,14
	LPM  R0,Z
	__PUTBR0MN _led_buff,1
; 0000 0164             led_buff[0]=led_table[0];
	LDI  R30,LOW(_led_table*2)
	LDI  R31,HIGH(_led_table*2)
	LPM  R0,Z
	STS  _led_buff,R0
; 0000 0165 
; 0000 0166              load_clr;
	CBI  0x12,5
	CBI  0x12,3
	SBI  0x12,6
	SBI  0x12,4
; 0000 0167 
; 0000 0168          } else if (timer_select == 1)
	RJMP _0x49
_0x40:
	LDI  R30,LOW(1)
	CP   R30,R2
	BRNE _0x4A
; 0000 0169             {
; 0000 016A                temp_select=10;
	LDI  R30,LOW(10)
	MOV  R9,R30
; 0000 016B             } else if (timer_select == 2)
	RJMP _0x4B
_0x4A:
	LDI  R30,LOW(2)
	CP   R30,R2
	BRNE _0x4C
; 0000 016C                {
; 0000 016D                   temp_select=20;
	LDI  R30,LOW(20)
	MOV  R9,R30
; 0000 016E                } else if (timer_select == 3)
	RJMP _0x4D
_0x4C:
	LDI  R30,LOW(3)
	CP   R30,R2
	BRNE _0x4E
; 0000 016F                   {
; 0000 0170                      temp_select=30;
	LDI  R30,LOW(30)
	MOV  R9,R30
; 0000 0171                   } else if (timer_select == 4)
	RJMP _0x4F
_0x4E:
	LDI  R30,LOW(4)
	CP   R30,R2
	BRNE _0x50
; 0000 0172                      {
; 0000 0173                         temp_select=40;
	LDI  R30,LOW(40)
	MOV  R9,R30
; 0000 0174                      } else if (timer_select == 5)
	RJMP _0x51
_0x50:
	LDI  R30,LOW(5)
	CP   R30,R2
	BRNE _0x52
; 0000 0175                         {
; 0000 0176                            temp_select=50;
	LDI  R30,LOW(50)
	MOV  R9,R30
; 0000 0177                         } else if (timer_select == 6)
	RJMP _0x53
_0x52:
	LDI  R30,LOW(6)
	CP   R30,R2
	BRNE _0x54
; 0000 0178                            {
; 0000 0179                             temp_select=60;
	LDI  R30,LOW(60)
	MOV  R9,R30
; 0000 017A                            } else if (timer_select == 7)
	RJMP _0x55
_0x54:
	LDI  R30,LOW(7)
	CP   R30,R2
	BRNE _0x56
; 0000 017B                               {
; 0000 017C                                timer_select=0;
	CLR  R2
; 0000 017D                               }
; 0000 017E 
; 0000 017F           if (timer_select!=0)
_0x56:
_0x55:
_0x53:
_0x51:
_0x4F:
_0x4D:
_0x4B:
_0x49:
	TST  R2
	BRNE PC+2
	RJMP _0x57
; 0000 0180          {
; 0000 0181            if (temp1<10)
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CP   R6,R30
	CPC  R7,R31
	BRSH _0x58
; 0000 0182           {
; 0000 0183 
; 0000 0184            led_buff[2]=led_table[temp]; //  
	MOVW R30,R4
	SUBI R30,LOW(-_led_table*2)
	SBCI R31,HIGH(-_led_table*2)
	LPM  R0,Z
	__PUTBR0MN _led_buff,2
; 0000 0185 
; 0000 0186            led_buff[1]=led_table[11];
	__POINTW1FN _led_table,11
	LPM  R0,Z
	__PUTBR0MN _led_buff,1
; 0000 0187 
; 0000 0188            led_buff[0]=led_table[13];
	__POINTW1FN _led_table,13
	LPM  R0,Z
	STS  _led_buff,R0
; 0000 0189           }
; 0000 018A 
; 0000 018B            if (temp1>9 && temp1<100)
_0x58:
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	CP   R30,R6
	CPC  R31,R7
	BRSH _0x5A
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CP   R6,R30
	CPC  R7,R31
	BRLO _0x5B
_0x5A:
	RJMP _0x59
_0x5B:
; 0000 018C           {
; 0000 018D            led_buff[2]=led_table[temp%10]; //  
	MOVW R26,R4
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21U
	SUBI R30,LOW(-_led_table*2)
	SBCI R31,HIGH(-_led_table*2)
	LPM  R0,Z
	__PUTBR0MN _led_buff,2
; 0000 018E            temp=temp/10;
	MOVW R26,R4
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21U
	MOVW R4,R30
; 0000 018F            led_buff[1]=led_table[temp%10];
	MOVW R26,R4
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21U
	SUBI R30,LOW(-_led_table*2)
	SBCI R31,HIGH(-_led_table*2)
	LPM  R0,Z
	__PUTBR0MN _led_buff,1
; 0000 0190 
; 0000 0191            led_buff[0]=led_table[13];
	__POINTW1FN _led_table,13
	LPM  R0,Z
	STS  _led_buff,R0
; 0000 0192           }
; 0000 0193              if (flags)
_0x59:
	SBIS 0x13,1
	RJMP _0x5C
; 0000 0194               {
; 0000 0195 
; 0000 0196                if (sek==0){sek=temp_select; flags=0;}
	TST  R8
	BRNE _0x5D
	MOV  R8,R9
	CBI  0x13,1
; 0000 0197                if(timer>0){timer--;} else{ timer=50; sek--;}
_0x5D:
	LDI  R30,LOW(0)
	CP   R30,R11
	BRSH _0x60
	DEC  R11
	RJMP _0x61
_0x60:
	LDI  R30,LOW(50)
	MOV  R11,R30
	DEC  R8
_0x61:
; 0000 0198                temp1=sek;
	MOV  R6,R8
	CLR  R7
; 0000 0199 
; 0000 019A                load_active;
	SBI  0x12,5
	SBI  0x12,3
	CBI  0x12,6
	CBI  0x12,4
; 0000 019B 
; 0000 019C               }
; 0000 019D                else
	RJMP _0x6A
_0x5C:
; 0000 019E               {
; 0000 019F                if(temp1<temp_select){temp1++;} else{ temp1=temp_select; flags=0;}
	MOV  R30,R9
	MOVW R26,R6
	LDI  R31,0
	CP   R26,R30
	CPC  R27,R31
	BRSH _0x6B
	MOVW R30,R6
	ADIW R30,1
	MOVW R6,R30
	SBIW R30,1
	RJMP _0x6C
_0x6B:
	MOV  R6,R9
	CLR  R7
	CBI  0x13,1
_0x6C:
; 0000 01A0                sek=temp_select;
	MOV  R8,R9
; 0000 01A1 
; 0000 01A2                load_clr;
	CBI  0x12,5
	CBI  0x12,3
	SBI  0x12,6
	SBI  0x12,4
; 0000 01A3               }
_0x6A:
; 0000 01A4          }
; 0000 01A5 
; 0000 01A6 
; 0000 01A7 
; 0000 01A8 
; 0000 01A9 
; 0000 01AA 
; 0000 01AB 
; 0000 01AC 
; 0000 01AD         delay_ms(20);
_0x57:
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 01AE 
; 0000 01AF        temp = temp1;
	MOVW R4,R6
; 0000 01B0 
; 0000 01B1 
; 0000 01B2 
; 0000 01B3       };
	RJMP _0x16
; 0000 01B4 }
_0x77:
	RJMP _0x77

	.DSEG
_led_buff:
	.BYTE 0x3

	.CSEG

	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__MODW21U:
	RCALL __DIVW21U
	MOVW R30,R26
	RET

;END OF CODE MARKER
__END_OF_CODE:
